package org.xbib.interlibrary.api.action;

public abstract class AbstractResponse<R extends Request> implements Response<R> {

    private final R request;

    private final Status status;

    private final Throwable throwable;

    public AbstractResponse(R request, Status status) {
        this(request, status, null);
    }

    public AbstractResponse(R request, Status status, Throwable throwable) {
        this.request = request;
        this.status = status;
        this.throwable = throwable;
    }

    @Override
    public R getRequest() {
        return request;
    }

    @Override
    public Status getStatus() {
        return status;
    }

    @Override
    public Throwable getThrowable() {
        return throwable;
    }
}
