package org.xbib.interlibrary.api.action;

import org.xbib.interlibrary.api.config.Configuration;
import org.xbib.settings.Settings;

public class DefaultServiceArguments implements ServiceArguments {

    private final Settings settings;

    private final String name;

    private final Settings serviceSettings;

    private final Configuration configuration;

    public DefaultServiceArguments(Settings settings,
                                   String name,
                                   Settings serviceSettings,
                                   Configuration configuration) {
        this.settings = settings;
        this.name = name;
        this.serviceSettings = serviceSettings;
        this.configuration = configuration;
    }

    @Override
    public Settings getSettings() {
        return settings;
    }

    @Override
    public String getName() {
        return name;
    }

    @Override
    public Settings getServiceSettings() {
        return serviceSettings;
    }

    @Override
    public String getServiceSettings(String key, String defaultValue) {
        return serviceSettings.get(key, defaultValue);
    }

    @Override
    public boolean getServiceSettingsAsBoolean(String key, boolean defaultValue) {
        return serviceSettings.getAsBoolean(key, defaultValue);
    }

    @Override
    public Configuration getConfiguration() {
        return configuration;
    }
}
