package org.xbib.interlibrary.api.action;

public interface ResponseBuilder<Req extends Request, Resp extends Response<Req>> {

    ResponseBuilder<Req, Resp> setRequest(Req request);

    ResponseBuilder<Req, Resp> setStatus(String key, Response.Status status);

    Response.Status getStatus();

    ResponseBuilder<Req, Resp> setThrowable(Throwable throwable);

    Throwable getThrowable();

    ResponseBuilder<Req, Resp> setThrowable(String key, String message, Throwable throwable);

    Resp build();
}
