package org.xbib.interlibrary.api.action;

import java.io.IOException;

public interface Service<Req extends Request, Resp extends Response<Req>, B extends ResponseBuilder<Req, Resp>>
        extends Comparable<Service<Req, Resp, B>> {

    String getName();

    void setEnabled(boolean enabled);

    boolean isEnabled();

    void addThrowable(Throwable throwable);

    Throwable getLastThrowable();

    void execute(Req request, B responseBuilder) throws IOException;

    void close() throws IOException;
}
