package org.xbib.interlibrary.api.action.worker;

import java.text.MessageFormat;
import java.util.Map;
import java.util.logging.Level;
import java.util.logging.Logger;

public class DefaultWorkerPoolListener<W extends WorkerPool<?>> implements WorkerPoolListener<W> {

    private static final Logger logger = Logger.getLogger(DefaultWorkerPoolListener.class.getName());

    public DefaultWorkerPoolListener() {
    }

    @Override
    public void success(W workerPool) {
        logger.log(Level.INFO, () -> MessageFormat.format("success of {0} ({1} executions)",
                workerPool, workerPool.getExecutionCounter()));
    }

    @Override
    public void failure(W workerPool, Map<Runnable, Throwable> exceptions) {
        logger.log(Level.SEVERE, () -> MessageFormat.format("failure of {0},  reason {1} ",
                workerPool, exceptions.toString()));
    }
}
