package org.xbib.interlibrary.api.action.worker;

import java.io.IOException;

/**
 * Worker interface for executing requests.
 */
public interface Worker<R> extends AutoCloseable {

    /**
     * Execute a request.
     *
     * @param request request
     * @throws IOException if execution fails
     */
    void execute(WorkerRequest<R> request) throws IOException;

    @Override
    void close() throws IOException;
}
