package org.xbib.interlibrary.api.action.worker;

import java.io.Closeable;
import java.io.IOException;
import java.util.concurrent.BlockingQueue;
import java.util.concurrent.atomic.AtomicLong;

public interface WorkerPool<R> extends Closeable, Iterable<WorkerRequest<R>> {

    void open() throws IOException;

    BlockingQueue<WorkerRequest<R>> getQueue();

    Worker<R> newWorker(String name, int count) throws IOException;

    WorkerRequest<R> newWorkerRequest(Object input, String origin);

    void submit(WorkerRequest<R> request);

    void afterExecute(Worker<R> worker, WorkerRequest<R> request);

    void setReturnCode(int returnCode);

    int getReturnCode();

    AtomicLong getExecutionCounter();
}
