package org.xbib.interlibrary.api.action.worker;

import java.util.concurrent.ThreadFactory;
import java.util.concurrent.atomic.AtomicInteger;

public class WorkerThreadFactory implements ThreadFactory {

    private final String name;

    private final AtomicInteger counter;

    public WorkerThreadFactory(String name) {
        this.name = name;
        this.counter = new AtomicInteger();
    }

    @Override
    public Thread newThread(Runnable r) {
        Thread thread = new Thread(r, name + "-" + counter.getAndIncrement());
        thread.setDaemon(true);
        return thread;
    }
}
