package org.xbib.interlibrary.api.config;

import java.util.List;
import java.util.Map;
import org.xbib.interlibrary.api.order.Circulation;
import org.xbib.settings.Settings;

public interface ConfigManager {

    Settings getSettings(String isil, Circulation circulation);

    <T> T getSettingsValue(String isil, Circulation circulation, String key);

    List<Settings> getSettingsByPrefix(String isil, Circulation circulation, String prefix);

    void putSettings(String isil, Circulation circulation, Settings settings);

    void putConfigValue(String isil, Circulation circulation, String key, Object value);

    void putConfigValues(String isil, Circulation circulation, String prefix, Map<String, Object> keyValues);

    void deleteConfigValue(String isil, Circulation circulation, String key);
}
