package org.xbib.interlibrary.api.event;

import java.time.LocalDateTime;
import org.xbib.interlibrary.api.order.Delivery;
import org.xbib.interlibrary.api.order.OrderEvent;
import org.xbib.interlibrary.api.order.Status;

public interface OrderEventManager {

    OrderEvent getOrderEvent(String eventKey);

    void putOrderEvent(OrderEvent event);

    void addOrderEventEntry(OrderEvent.Entry entry);

    void addOrderEventEntry(Status status,
                            OrderEvent.OrderEventType type,
                            OrderEvent.OrderEventCode code,
                            String message,
                            LocalDateTime localDateTime,
                            String ordernumber,
                            String transactionId,
                            String library,
                            String ref);

    Delivery getDelivery();

    Delivery getDeliveryOfOrderNumber(String orderNumber);

    Delivery getDeliveryOfLibrary(String isil, int days);

    LocalDateTime getLastSuccessfulDelivery(String orderNumber);

    LocalDateTime getLastSuccessfulConversion(String orderNumber);
}
