package org.xbib.interlibrary.api.library;

public class DefaultDomain implements Domain {

    private final String name;

    private final String organization;

    public DefaultDomain(String name, String organization) {
        this.name = name;
        this.organization = organization;
    }

    public String getName() {
        return name != null ? name : "undefined";
    }

    public String getOrganization() {
        return organization != null ? organization : "undefined";
    }

    @Override
    public String toString() {
        return name;
    }

    @Override
    public int compareTo(Domain o) {
        return name.compareTo(o.getName());
    }

    @Override
    public boolean equals(Object o) {
        return o instanceof Domain && name.equals(((Domain) o).getName());
    }

    @Override
    public int hashCode() {
        return name.hashCode();
    }
}
