package org.xbib.interlibrary.api.library;

import java.util.List;
import java.util.Map;

import org.xbib.datastructures.tiny.TinyMap;

public class DefaultLibraryNotificationAddress
        extends DefaultLibrarySenderAddress implements LibraryNotificationAddress {

    private String shortName;

    private String openingHours;

    private String openingHoursComments;

    private Map<String, String> phoneNumber;

    private String homePageURL;

    private String email;

    private Map<String, String> emails;

    private String latitude;

    private String longitude;

    public DefaultLibraryNotificationAddress() {
    }

    public void setShortName(String shortName) {
        this.shortName = shortName;
    }

    public String getShortName() {
        return shortName;
    }

    public void setOpeningHours(String openingHours) {
        this.openingHours = openingHours;
    }

    @Override
    public String getOpeningHours() {
        return openingHours;
    }

    public void setOpeningHoursComments(String openingHoursComments) {
        this.openingHoursComments = openingHoursComments;
    }

    @Override
    public String getOpeningHoursComments() {
        return openingHoursComments;
    }

    public void setPhoneNumber(Map<String, String> phoneNumber) {
        this.phoneNumber = phoneNumber;
    }

    @Override
    public Map<String, String> getPhoneNumber() {
        return phoneNumber;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    @Override
    public String getEmail() {
        return email;
    }

    public void setEmails(Map<String, String> emails) {
        this.emails = emails;
    }

    @Override
    public Map<String, String> getEmails() {
        return emails;
    }

    public void setHomePageURL(String homePageURL) {
        this.homePageURL = homePageURL;
    }

    @Override
    public String getHomePageURL() {
        return homePageURL;
    }

    public void setLatitude(String latitude) {
        this.latitude = latitude;
    }

    @Override
    public String getLatitude() {
        return latitude;
    }

    public void setLongitude(String longitude) {
        this.longitude = longitude;
    }

    @Override
    public String getLongitude() {
        return longitude;
    }

    @Override
    public Map<String, Object> asMap() {
        TinyMap.Builder<String, Object> notification = TinyMap.builder();
        notification.putIfNotNull("name", getName());
        notification.putIfNotNull("shortname", getShortName());
        notification.putIfNotNull("street", getStreet());
        notification.putIfNotNull("zip", getZipCode());
        notification.putIfNotNull("place", getPlace());
        notification.putIfNotNull("postofficebox", getPostOfficeBox());
        notification.putIfNotNull("postofficeboxzip", getPostOfficeBoxZipCode());
        notification.putIfNotNull("country", getCountry());
        notification.putIfNotNull("province", getProvince());
        notification.putIfNotNull("email", getEmail());
        notification.putIfNotNull("emails", getEmails());
        notification.putIfNotNull("phone", getPhoneNumber());
        notification.putIfNotNull("homepage", getHomePageURL());
        notification.putIfNotNull("openinghours", getOpeningHours());
        notification.putIfNotNull("openinghourscomments", getOpeningHoursComments());
        notification.putIfNotNull("latitude", getLatitude());
        notification.putIfNotNull("longitude", getLongitude());
       return notification.build();
    }

    @Override
    public List<String> asLines(AddressStyle addressStyle, List<String> prepend, List<String> append) {
        List<String> lines = super.asLines(addressStyle, prepend, List.of());
        boolean emailFound = false;
        if (getEmails() != null && !getEmails().isEmpty()) {
            for (Map.Entry<String, String> entry: getEmails().entrySet()) {
                if ("passive Fernleihe".equals(entry.getKey())) {
                    lines.add(entry.getValue());
                    emailFound = true;
                }
            }
        }
        if (!emailFound && getEmail() != null && !getEmail().isEmpty()) {
            lines.add(getEmail());
        }
        if (!getPhoneNumber().isEmpty()) {
            lines.add(String.join("; ", getPhoneNumber().values()));
        }
        if (getOpeningHours() != null && !getOpeningHours().isEmpty()) {
            lines.add(getOpeningHours());
        }
        if (getOpeningHoursComments() != null && !getOpeningHoursComments().isEmpty()) {
            lines.add(getOpeningHoursComments());
        }
        if (getHomePageURL() != null && !getHomePageURL().isEmpty()) {
            lines.add(getHomePageURL());
        }
        lines.addAll(append);
        return lines;
    }
}
