package org.xbib.interlibrary.api.library;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import org.xbib.datastructures.tiny.TinyMap;

public class DefaultLibrarySenderAddress implements LibrarySenderAddress {

    private String name;

    private String street;

    private String zipCode;

    private String place;

    private String province;

    private String country;

    private String postOfficeBox;

    private String postOfficeBoxZipCode;

    public DefaultLibrarySenderAddress() {
    }

    public void setName(String name) {
        this.name = name;
    }

    @Override
    public String getName() {
        return name;
    }

    public void setStreet(String street) {
        this.street = street;
    }

    @Override
    public String getStreet() {
        return street;
    }

    public void setZipCode(String zipCode) {
        this.zipCode = zipCode;
    }

    @Override
    public String getZipCode() {
        return zipCode;
    }

    public void setPlace(String place) {
        this.place = place;
    }

    @Override
    public String getPlace() {
        return place;
    }

    public void setProvince(String province) {
        this.province = province;
    }

    @Override
    public String getProvince() {
        return province;
    }

    public void setCountry(String country) {
        this.country = country;
    }

    @Override
    public String getCountry() {
        return country;
    }

    public void setPostOfficeBox(String postOfficeBox) {
        this.postOfficeBox = postOfficeBox;
    }

    @Override
    public String getPostOfficeBox() {
        return postOfficeBox;
    }

    public void setPostOfficeBoxZipCode(String postOfficeBoxZipCode) {
        this.postOfficeBoxZipCode = postOfficeBoxZipCode;
    }

    @Override
    public String getPostOfficeBoxZipCode() {
        return postOfficeBoxZipCode;
    }

    @Override
    public Map<String, Object> asMap() {
        TinyMap.Builder<String, Object> sender = TinyMap.builder();
        sender.putIfNotNull("name", getName());
        sender.putIfNotNull("street", getStreet());
        sender.putIfNotNull("zip", getZipCode());
        sender.putIfNotNull("place", getPlace());
        sender.putIfNotNull("postofficebox", getPostOfficeBox());
        sender.putIfNotNull("postofficeboxzip", getPostOfficeBoxZipCode());
        return sender.build();
    }

    @Override
    public List<String> asLines(AddressStyle addressStyle) {
        return asLines(addressStyle, List.of(), List.of());
    }

    @Override
    public List<String> asLines(AddressStyle addressStyle, List<String> prepend, List<String> append) {
        List<String> lines = new ArrayList<>(prepend);
        if (getName() != null && !getName().isEmpty()) {
            lines.add(getName());
        }
        if (addressStyle == AddressStyle.POSTOFFICEBOX && getPostOfficeBoxZipCode() != null) {
            if (getPostOfficeBox() !=  null) {
                lines.add("Postfach " + getPostOfficeBox());
            }
            if (getPostOfficeBoxZipCode() != null && !getPostOfficeBoxZipCode().isEmpty() && getPlace() != null && !getPlace().isEmpty()) {
                lines.add(getPostOfficeBoxZipCode() + " " + getPlace());
            }
        } else {
            if (getStreet() != null && !getStreet().isEmpty()) {
                lines.add(getStreet());
            }
            if (getZipCode() != null && !getZipCode().isEmpty() && getPlace() != null && !getPlace().isEmpty()) {
                lines.add(getZipCode() + " " + getPlace());
            }
        }
        lines.addAll(append);
        return lines;
    }
}
