package org.xbib.interlibrary.api.library;

import org.xbib.interlibrary.api.config.Configuration;

import java.util.Collection;
import java.util.Map;
import java.util.function.Predicate;

public interface Library {

    void setISIL(String isil);

    String getISIL();

    void setSigel(String sigel);

    String getSigel();

    void setEzbId(String ezbId);

    String getEzbId();

    void setAliases(Collection<String> aliases);

    Collection<String> getAliases();

    void setName(String name);

    String getName();

    void setFullName(String name);

    String getFullName();

    void setRegisteredInterlibrary(boolean isRegisteredInterlibrary);

    boolean isRegisteredInterlibrary();

    void setCopyInterlibrary(boolean isCopyInterlibraryProvider);

    boolean isCopyInterlibrary();

    void setOnlineInterlibrary(boolean isOnlineInterlibrary);

    boolean isOnlineInterlibrary();

    void setSubLibrary(boolean isSubLibrary);

    boolean isSubLibrary();

    void setLastResort(boolean lastresort);

    boolean isLastResort();

    void setOrganization(boolean isOrganization);

    boolean isOrganization();

    void setPublic(boolean isPublic);

    boolean isPublic();

    void setDomain(Domain domain);

    Domain getDomain();

    String getDomainName();

    void setSelf(Collection<String> self);

    Collection<String> getSelf();

    void setSelfPredicate(Predicate<Library> selfPredicate);

    Predicate<Library> getSelfPredicate();

    void setLocal(Collection<String> local);

    Collection<String> getLocal();

    void setLocalPredicate(Predicate<Library> localPredicate);

    Predicate<Library> getLocalPredicate();

    void setAccept(Collection<String> accept);

    Collection<String> getAccept();

    void setPrefer(Collection<String> prefer);

    Collection<String> getPrefer();

    void setPlace(Place place);

    Place getPlace();

    void setGroups(Collection<String> groups);

    Collection<String> getGroups();

    void setStations(Collection<Station> stations);

    Collection<Station> getStations();

    Predicate<Library> getGroupPredicate();

    void setServicesPredicate(Predicate<LibraryService> servicesPredicate);

    Predicate<LibraryService> getServicesPredicate();

    void setPriority(Integer priority);

    Integer getPriority();

    void setSenderAddress(LibrarySenderAddress address);

    LibrarySenderAddress getSenderAddress();

    void setNotificationAddress(LibraryNotificationAddress address);

    LibraryNotificationAddress getNotificationAddress();

    void setPostalAddress(LibraryPostalAddress address);

    LibraryPostalAddress getPostalAddress();

    void setActiveEmail(String email);

    String getActiveEmail();

    void setPassiveEmail(String email);

    String getPassiveEmail();

    void setReservationEmail(String email);

    String getReservationEmail();

    Map<String, Object> asMap();

    static Library fromMap(Configuration configuration,
                           String isil,
                           Map<String, Object> map) {
        LibraryArguments arguments = new DefaultLibraryArguments(configuration, isil);
        arguments.setMap(map);
        return new DefaultLibrary(arguments);
    }
}
