package org.xbib.interlibrary.api.library;

import java.util.Locale;
import java.util.logging.Level;
import java.util.logging.Logger;

public enum Material {

    MAP,
    ELECTRONIC_RESOURCE,
    ONLINE_RESOURCE,
    GLOBE,
    TACTILE,
    PROJECTED_GRAPHIC,
    MICROFORM,
    NON_PROJECTED_GRAPHIC,
    MOTION_PICTURE,
    KIT,
    NOTATED_MUSIC,
    REMOTE_SENSING_IMAGE,
    SOUND_RECORDING,
    TEXT,
    VIDEO_RECORDING,
    UNSPECIFIED,
    UNDEFINED;

    private static final Logger logger = Logger.getLogger(Material.class.getName());

    public String toValue() {
        return name().toLowerCase(Locale.ROOT);
    }

    public static Material fromValue(String value) {
        try {
            return value != null ? Material.valueOf(value.toUpperCase(Locale.ROOT)) : UNDEFINED;
        } catch (IllegalArgumentException e) {
            logger.log(Level.WARNING, "unknown material: " + value);
            return UNDEFINED;
        }
    }
}

/*
        CARRIERTYPES.put("online resource", "Online-Ressource");
        CARRIERTYPES.put("volume", "gedruckte Ressource");
        CARRIERTYPES.put("sheet", "gedruckte Ressource");
        CARRIERTYPES.put("computer disc", "Datenträger für Computer");
        CARRIERTYPES.put("computer tape cassette", "Datenträger für Computer");
        CARRIERTYPES.put("computer chip cartridge", "Datenträger für Computer");
        CARRIERTYPES.put("audiotape reel", "Audio");
        CARRIERTYPES.put("sound track reel", "Audio");
        CARRIERTYPES.put("microopaque", "Microfiche");
        CARRIERTYPES.put("microfiche", "Microfiche");
        CARRIERTYPES.put("microfiche cassette", "Mikrofilm");
        CARRIERTYPES.put("microfilm cartridge", "Mikrofilm");
        CARRIERTYPES.put("microfilm cassette", "Mikrofilm");
        CARRIERTYPES.put("aperture card", "Mikrofilm");
        CARRIERTYPES.put("microfilm roll", "Mikrofilm");
        CARRIERTYPES.put("microfilm reel", "Mikrofilm");
        CARRIERTYPES.put("microfilm slip", "Mikrofilm");
        CARRIERTYPES.put("microscope slide", "andere");
        CARRIERTYPES.put("slide", "Datenträger für Computer");
        CARRIERTYPES.put("film cartridge", "Film");
        CARRIERTYPES.put("film cassette", "Film");
        CARRIERTYPES.put("film roll", "Film");
        CARRIERTYPES.put("film reel", "Film");
        CARRIERTYPES.put("filmstrip", "Film");
        CARRIERTYPES.put("filmslip", "Film");
        CARRIERTYPES.put("filmstrip cartridge", "Film");
        CARRIERTYPES.put("overhead transparency", "andere");
        CARRIERTYPES.put("stereograph card", "andere");
        CARRIERTYPES.put("stereograph disc", "andere");
        CARRIERTYPES.put("flipchart", "andere");
        CARRIERTYPES.put("object", "andere");
        CARRIERTYPES.put("card", "andere");
        CARRIERTYPES.put("roll", "andere");
        CARRIERTYPES.put("videotape reel", "andere");
        CARRIERTYPES.put("video cartridge", "andere");
        CARRIERTYPES.put("videodisc", "andere");
        CARRIERTYPES.put("videocassettte", "andere");
        CARRIERTYPES.put("microform", "Mikroform");
        CARRIERTYPES.put("microform reel", "Mikroform");
        CARRIERTYPES.put("other", "andere");
        CARRIERTYPES.put("unspecified", "nicht angegeben");
*/