package org.xbib.interlibrary.api.order;

public enum Circulation {

    LOAN("Leihe", 'L',  'L', "loan"),

    COPY("Kopie", 'C', 'K', "copy-non-returnable"),

    FORM("Leihschein", 'F', 'E', "loan-or-copy"),

    SCAN("Scan", 'S', 'S', "none"), /* Octopus */

    RESERVATION("Vormerkung", 'V', 'V', "reservation-only");

    private final String label;

    private final char zflCode;

    private final char medeaCode;

    private final String illCode;

    Circulation(String label,
                char zflCode,
                char medeaCode,
                String illCode) {
        this.label = label;
        this.zflCode = zflCode;
        this.medeaCode = medeaCode;
        this.illCode = illCode;
    }

    public String getLabel() {
        return label;
    }

    public char getZflCode() {
        return zflCode;
    }

    public char getMedeaCode() {
        return medeaCode;
    }

    public String getInterlibraryCode() {
        return illCode;
    }
}
