package org.xbib.interlibrary.api.order;

public class DefaultStatus implements Status {

    private final Code statusCode;

    private final String statusText;

    private final String statusTranslation;

    private final Substatus substatus;

    private final String substatusText;

    private final String substatusTranslation;

    public DefaultStatus(Code statusCode) {
        this(statusCode, null, null, Substatus.UNDEFINED, null, null);
    }

    public DefaultStatus(Code statusCode, Substatus substatus) {
        this(statusCode, null, null, substatus, null, null);
    }

    public DefaultStatus(Code statusCode,
                         String statusText,
                         String statusTranslation,
                         Substatus substatus,
                         String substatusText,
                         String substatusTranslation) {
        this.statusCode = statusCode;
        this.statusText = statusText;
        this.statusTranslation = statusTranslation;
        this.substatus = substatus;
        this.substatusText = substatusText;
        this.substatusTranslation = substatusTranslation;
    }

    @Override
    public Code getCode() {
        return statusCode;
    }

    @Override
    public Substatus getSubstatus() {
        return substatus;
    }

    @Override
    public String getStatusText() {
        return statusText;
    }

    @Override
    public String getStatusTranslation() {
        return statusTranslation;
    }

    @Override
    public String getSubstatusText() {
        return substatusText;
    }

    @Override
    public String getSubstatusTranslation() {
        return substatusTranslation;
    }

    @Override
    public String toString() {
        return statusCode + "[" + substatus +"]";
    }
}
