package org.xbib.interlibrary.api.order;

import java.io.IOException;
import java.time.LocalDateTime;
import java.util.Iterator;
import java.util.Map;

public interface Delivery {

    interface Entry {

        Long getId();

        OrderEvent.OrderEventType getType();

        OrderEvent.OrderEventCode getCode();

        String getCodeTranslation();

        LocalDateTime getTime();

        Status getStatus();

        String getMessage();

        String getOrderNumber();

        String getTransactionId();

        String getLibrary();

        String getUserId();

        String getRef();

        String toJson() throws IOException;

        Map<String, Object> asMap();
    }

    Iterator<? extends Entry> getEntries();

    Iterator<? extends Entry> getEntriesInReverseOrder();

    String toJson() throws IOException;

    Map<String, Object> asMap();
}
