package org.xbib.interlibrary.api.order;

import org.xbib.interlibrary.api.library.Role;

import java.io.IOException;
import java.util.Map;

public interface Order {

    OrderSystem getOrderSystem();

    Circulation getCirculation();

    Priority getPriority();

    DeliveryScope getDeliveryScope();

    DeliveryStyle getDeliveryStyle();

    NotifyMethod getNotifyMethod();

    NotifyStyle getNotifyStyle();

    Status getStatus();

    String getOrderNumber();

    String getIsil(Role role);

    Requester getRequester();

    Supply getSupplier();

    BibliographicData getBibliographicData();

    String toJson() throws IOException;

    Map<String, Object> asMap();

}
