package org.xbib.interlibrary.api.order;

import org.xbib.interlibrary.api.library.Role;

import java.time.LocalDateTime;
import java.util.Collection;
import java.util.function.Predicate;

public interface OrderSearchParameters {

    OrderSystem getOrderSystem();

    String getISIL();

    Role getRole();

    Circulation getCirculation();

    Collection<Priority> getPriority();

    DeliveryScope getDeliveryScope();

    Status getStatus();

    LocalDateTime getFromOrderTime();

    LocalDateTime getToOrderTime();

    LocalDateTime getFromLastActivityTime();

    LocalDateTime getToLastActivityTime();

    LocalDateTime getFromSupplyTime();

    LocalDateTime getToSupplyTime();

    Integer getOffset();

    Integer getSize();

    String getSortKey();

    boolean getSortDir();

    interface Builder {

        OrderSearchParameters build();
    }
}
