package org.xbib.interlibrary.api.order.statistics;

import org.xbib.interlibrary.api.library.Role;

import java.io.IOException;
import java.time.LocalDateTime;
import java.util.Map;

public interface StatisticsManager {

    Statistics getAccountingStatistics(LocalDateTime startDay, LocalDateTime endDay) throws IOException;

    void putRoyaltiesStatistics(Role role, LocalDateTime startDay, LocalDateTime endDay) throws IOException;

    void putRoyaltiesStatisticsErrata(Role role, String orderNumber, String mode);

    Map.Entry<LocalDateTime, LocalDateTime> findRoyaltiesStatisticsMinMax(Role role);

    Map.Entry<LocalDateTime, LocalDateTime> findRoyaltiesStatisticsMinMax(Role role,
                                                                          String isil);

    Map.Entry<LocalDateTime, LocalDateTime> findRoyaltiesStatisticsMinMax(Role role,
                                                                          LocalDateTime startDay,
                                                                          LocalDateTime endDay);

    Map.Entry<LocalDateTime, LocalDateTime> findRoyaltiesStatisticsMinMax(Role role,
                                                                          LocalDateTime startDay,
                                                                          LocalDateTime endDay,
                                                                          String isil);

    Statistics getRoyaltiesStatistics(Role role, LocalDateTime startDay, LocalDateTime endDay) throws IOException;

    Statistics getRoyaltiesStatistics(Role role, LocalDateTime startDay, LocalDateTime endDay, String isil) throws IOException;

    Statistics getTitleStatistics(LocalDateTime startDay, LocalDateTime endDay) throws IOException;

    Statistics getOrderTitleDE38M(LocalDateTime startDay, LocalDateTime endDay) throws IOException;

    Statistics getOrderTitleDE38MRequester(LocalDateTime startDay, LocalDateTime endDay) throws IOException;

    Statistics getOrderTitleDE38MKoelnBonn(LocalDateTime startDay, LocalDateTime endDay) throws IOException;
}
