package org.xbib.interlibrary.api.order.tracking;

import java.io.IOException;
import java.time.LocalDateTime;
import java.util.List;
import java.util.Map;
import javax.xml.stream.XMLStreamException;

import org.xbib.interlibrary.api.order.Circulation;
import org.xbib.interlibrary.api.order.Status;

public interface TrackedOrder {

    interface Entry {

        int getPos();

        LocalDateTime getTime();

        String getSupplierId();

        String getSupplierName();

        String getInfo();

        Status getStatus();

        boolean isTrackable();

        Map<String, Object> asMap();

        String toJson() throws IOException;

    }

    String getOrderNumber();

    String getRequesterId();

    String getRequesterName();

    String getClientId();

    LocalDateTime getTime();

    Circulation getCirculation();

    String getTransactionId();

    String getTransactionQualifier();

    String getSupplierId();

    String getSupplierName();

    String getItemAuthor();

    String getItemTitle();

    String getItemTitleOfArticle();

    String getItemPublisher();

    String getItemPublisherPlace();

    String getItemPublicationDate();

    String getPickupLocation();

    List<? extends Entry> getEntries();

    boolean isEmpty();

    Map<String, Object> asMap();

    String toJson() throws IOException;

    String toXml(DisplayStyle displayStyle) throws XMLStreamException;
}
