package org.xbib.interlibrary.api.order.tracking;

import java.io.IOException;
import java.time.LocalDateTime;
import java.util.List;
import java.util.Map;
import javax.xml.stream.XMLStreamException;

import org.xbib.interlibrary.api.order.Circulation;
import org.xbib.interlibrary.api.order.DeliveryStyle;
import org.xbib.interlibrary.api.order.NotifyStyle;
import org.xbib.interlibrary.api.order.Status;

public interface TrackedOrderList {

    interface Entry {

        int getPos();

        LocalDateTime getTime();

        Circulation getCirculation();

        DeliveryStyle getDeliveryStyle();

        NotifyStyle getNotifyStyle();

        Status getStatus();

        String getOrderNumber();

        String getTransactionId();

        String getTransactionQualifier();

        String getSupplierId();

        String getSupplierName();

        String getItemAuthor();

        String getItemTitle();

        String getItemTitleOfArticle();

        String getItemPublisher();

        String getItemPublicationDate();

        String getPickupLocation();

        Map<String, Object> asMap();

        String toJson() throws IOException;

    }

    String getRequesterId();

    String getRequesterName();

    String getClientId();

    long getTotal();

    List<? extends Entry> getEntries();

    boolean isEmpty();

    void add(TrackedOrderList trackedOrderList);

    Map<String, Object> asMap();

    String toJson() throws IOException;

    String toXml(DisplayStyle displayStyle, int from, int to) throws XMLStreamException;

}
