package org.xbib.interlibrary.api.product;

public class DefaultProduct implements Product, Comparable<Product> {

    private final String isil;

    private final String name;

    public DefaultProduct(String isil, String name) {
        this.isil = isil;
        this.name = name;
    }

    @Override
    public String getISIL() {
        return isil;
    }

    @Override
    public String getName() {
        return name;
    }

    @Override
    public String toString() {
        return isil;
    }

    @Override
    public int compareTo(Product o) {
        return isil.compareTo(o.getISIL());
    }

    @Override
    public boolean equals(Object o) {
        return o instanceof Product && isil.equals(((Product) o).getISIL());
    }

    @Override
    public int hashCode() {
        return isil.hashCode();
    }
}
