package org.xbib.interlibrary.api.route;

import java.io.IOException;
import java.time.LocalDateTime;
import java.util.Collection;
import java.util.List;
import java.util.Map;
import org.xbib.interlibrary.api.library.LibraryService;
import org.xbib.interlibrary.api.order.Circulation;

public interface Route {

    interface Entry {

        int getPos();

        boolean isActive();

        LocalDateTime getTime();

        String getIsil();

        String getName();

        String getDomain();

        String getOrganization();

        boolean isOrganization();

        String getTransportService();

        Circulation getCirculation();

        Collection<LibraryService> getServices();

        String toJson() throws IOException;

        Map<String, Object> asMap();
    }

    int findPriority(String isil);

    List<Map<String, Object>> getLinks();

    List<Map<String, Object>> getLinkedIndicators();

    List<String> getPrevious();

    List<String> getNext();

    List<String> getNextSignatures();

    List<? extends Entry> getEntries();

    String toJson() throws IOException;

    Map<String, Object> asMap();
}
